IF 0  ; 
                      Build this template with "CONSOLE ASSEMBLE AND LINK"
ENDIF ; 

    include \masm32\include\masm32rt.inc

    utoa3 PROTO :DWORD,:DWORD

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL pbuf  :DWORD
    LOCAL buffer[128]:BYTE

    push ebx
    push esi
    push edi

    mov pbuf, ptr$(buffer)
    invoke utoa3,1234567890,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa3,123456789,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa3,12345678,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa3,1234567,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa3,123456,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa3,12345,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa3,1234,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa3,123,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa3,12,pbuf
    print pbuf,13,10

    mov pbuf, ptr$(buffer)
    invoke utoa3,1,pbuf
    print pbuf,13,10

    jmp quit    ; comment out to run following exhaustive test

  ; ===========================================

    xor esi, esi
    xor ebx, ebx

  @@:
    add ebx, 1
    mov pbuf, ptr$(buffer)
    invoke utoa3,esi,pbuf
    mov edi, ustr$(esi)

    invoke szCmp,pbuf,edi

    .if eax == 0
      print pbuf,13,10
      print "error at "
      print ustr$(esi),13,10
    .endif

    .if ebx > 1024*1024*2
      print "."
      xor ebx, ebx
    .endif

    add esi, 1

    cmp esi, -1
    jb @B

  quit:

    pop edi
    pop esi
    pop ebx

    ret

main endp

;  

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

utoa3 proc dwNumber:DWORD, pszString:DWORD

    mov edx, [esp+4]

    cmp edx, 9
    ja @F
    mov edx, 1
    jmp nxt

  @@:
    cmp edx, 99
    ja @F
    mov edx, 2
    jmp nxt

  @@:
    cmp edx, 999
    ja @F
    mov edx, 3
    jmp nxt

  @@:
    cmp edx, 9999
    ja @F
    mov edx, 4
    jmp nxt

  @@:
    cmp edx, 99999
    ja @F
    mov edx, 5
    jmp nxt

  @@:
    cmp edx, 999999
    ja @F
    mov edx, 6
    jmp nxt

  @@:
    cmp edx, 9999999
    ja @F
    mov edx, 7
    jmp nxt

  @@:
    cmp edx, 99999999
    ja @F
    mov edx, 8
    jmp nxt

  @@:
    cmp edx, 999999999
    ja @F
    mov edx, 9
    jmp nxt

  @@:
    mov edx, 10

  nxt:
    mov eax, [esp+4]            ; src
    mov ecx, [esp+8]            ; lpdest             ; buffer address

    push ebx
    push esi
    push edi

    mov esi, 0CCCCCCCDh         ; "magic number" multiplier for division by 10
    mov ebx, 10
    add ecx, edx                ; add required buffer length to start address
    mov BYTE PTR [ecx], 0       ; write the terminator
    sub ecx, 1                  ; decrement down to first write position

  @@:
    mul esi                     ; multiply by magic number
    shrd eax, edx, 3            ; binary fractional "remainder" back in EAX
    shr edx, 3                  ; EDX = quotient
    add eax, 1                  ; precaution against occasional "underflow"
    mov edi, edx                ; save current quotient for next division
    mul ebx                     ; x10 gets "decimal" remainder into EDX
    add dl, 30h                 ; convert remainder to ascii
    mov [ecx], dl               ; insert it into buffer
    sub ecx, 1                  ; decrement buffer location
    mov eax, edi                ; retrieve current quotient
    test eax, eax               ; test if done
    jz @F                       ; continue if not done

    mul esi                     ; multiply by magic number
    shrd eax, edx, 3            ; binary fractional "remainder" back in EAX
    shr edx, 3                  ; EDX = quotient
    add eax, 1                  ; precaution against occasional "underflow"
    mov edi, edx                ; save current quotient for next division
    mul ebx                     ; x10 gets "decimal" remainder into EDX
    add dl, 30h                 ; convert remainder to ascii
    mov [ecx], dl               ; insert it into buffer
    sub ecx, 1                  ; decrement buffer location
    mov eax, edi                ; retrieve current quotient
    test eax, eax               ; test if done
    jnz @B                      ; continue if not done


  @@:
    pop edi
    pop esi
    pop ebx

    mov eax, [esp+8]

    ret 8

utoa3 endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

;  

end start

























